/*
 * Licensed under BSD license.  See LICENCE.TXT  
 *
 * Produced by:	Jeff Lait
 *
 *      	7DRL Development
 *
 * NAME:        mapdata.h ( Save Scummer Library, C++ )
 *
 * COMMENTS:
 *	Contains an array of ints which can be copy-on-writed.
 */

#ifndef __mapdata__
#define __mapdata__

#include "mygba.h"

#include <iostream>
using namespace std;

class MAPDATA_REF;

class MAPDATA
{
public:
		 MAPDATA();
		 MAPDATA(int i);	// I should clean up pointer...
    explicit	 MAPDATA(int width, int height);
		 MAPDATA(const MAPDATA &data);
    
    virtual	~MAPDATA();

    MAPDATA 	&operator=(const MAPDATA &data);

    // For some reason I had myDistMaps(i)() access the non-const version
    // resulting in some serious performance penalty in getDist calls.
    // Since that is very, very, bad, I've opted for safety and renamed
    // the write accessor
    int		 operator()(int x, int y) const;

    int		&data(int x, int y);

    int		 getWidth() const;
    int		 getHeight() const;

    // Fill with constant.
    void	 constant(int value);

    void	 load(istream &is);
    void	 save(ostream &os) const;

protected:
    const int	*readData() const;
    int		*writeData();

private:
    MAPDATA_REF	*myRef;
    int		 myWidth, myHeight;
};

#endif

